#!/bin/bash

##############################################################################
# This program is free software. You can redistribute it and/or modify       #
# it under the terms of the GNU General Public License as published by       #
# the Free Software Foundation; either version 2 of the License.             #
##############################################################################

# Dependencias
# Iptables , iproute2 , modulos do kernel de CBQ QoS
# Iptables: necessita de  iptable_mangle e ipt_MARK

##################
#INSTALACAO
# crie o diretorio controle_banda dentro do seu /etc
# mkdir /etc/controle_banda
# dentro deste diretorio crie os arquivos ips e interfaces
# touch /etc/controle_banda/ips
# touch /etc/controle_banda/interfaces
# depois edite o ips e o interfaces 
# colocando dentro do ips
# os ips que vc deseja limitar 1 por linha no seguinte formato
# ip:ratein:rateout ex: 10.0.1.2:97:33
# e no interfaces as interfaces que vc usa na sua maquina
# no formato ethx ex: eth0
# 1 por linha tambem :)))
#
# Para rodar coloque o script dentro do seu rc.local
# Para remover as regras digite controle_banda.sh stop
#
##################

#Checa se o usuario eh root
if [ $(whoami) != root ]
then
	echo "Voce nao e root"
	exit 1
fi

# Instalacao do sistema

finstall(){
#verifica a existencia do destino
if [ -d /etc/controle_banda ]
then
	echo "Sistema ja instalado."
else
	mkdir /etc/controle_banda
	INST_IP=0
	#Loop para configuracao de IPs
	echo "Configurando IPs. Digite fim na configuracao de IP para terminar"
	while [ $INST_IP != fim ]
	do
		read -p "Entre com IP: " INST_IP
		if [ $INST_IP = "fim" ]
		then
			break
		fi
		read -p "Entre com Rate-IN: " INST_RATE_IN
		read -p "Entre com Rate-OUT: " INST_RATE_OUT
		echo "$INST_IP:$INST_RATE_IN:$INST_RATE_OUT" >> /etc/controle_banda/ips
	done
	INST_INT=0
	#Loop para configuracao de Interfaces
	echo "Configurando Interfaces. Digite fim para terminar"
	while [ $INST_INT != "fim" ]
	do
		read -p "Entre com Interface: " INST_INT
		if [ $INST_INT = "fim" ]
		then
			break
		fi
		echo $INST_INT >> /etc/controle_banda/interfaces
	done
fi
}

#PATH para os executaveis
#Devem ser descobertos automaticamente

IPTABLES="iptables"
TC="tc"
GREP="grep"
CUT="cut"
EXPR="expr"

####
# IMPORTANTE!!!! USAMOS OS COMANDO
#        iptables -F -t mangle
# Isso fara com que se voce tem alguma regra no seu mangle no iptables
# ou alguma regra no input ou output no seu ipchains esta regra sera apagada
# Para que voce nao perca suas regras de Firewall do iptables
# Caso use alguma coisa no mangle do iptables ou alguma coisa no input/output 
# no ipchains sete seu script de regras abaixo abaixo
#Lembrando que usamos o mangle apartir do mark 2 e este vai gerando um mark novo
#ate acabar seus ips ou seja se voce fizer pra 250 ips o ultimo mark sera o 252
#Caso use o Mark tente comecar apartir do 1000 para evitar Marks Iguais
#script=/path/seuscript.sh
script=0

##########################################################################################################
#Inicio da Configuracao



comum()
{
#Arquivos de Configuracao
ips=/etc/controle_banda/ips
interfaces=/etc/controle_banda/interfaces

##########################################################
# Opcao de instalacao e remocao
#########################################################


#############
# Interfaces
redelocal=eth1
redelocal2=inexistente
internet=eth0
#############

#Fim da configuracao
##########################################################################################################
 modprobe iptable_mangle
 modprobe ipt_MARK

} #fim do comum

#inicio do markador :)
mark=2

#Stop e Start colocados dentro de funcoes

fstop(){
		comum
		echo "Removendo Regras"
		for iface in `cat $interfaces`
		do
			$TC qdisc del dev $iface root
		done
			$IPTABLES -F -t mangle
}



fstart(){
		comum
		#Limpar Regras antes de rodar o script ):)
		$IPTABLES -F -t mangle

		#adicionado interfaces
		for iface in `cat $interfaces`
			do
				#$TC qdisc del dev $iface root
				$TC qdisc add dev $iface root handle 1 cbq bandwidth 100Mbit avpkt 1000 cell 8
				$TC class change dev $iface root cbq weight 1Mbit allot 1514
			done

		####


		for ip in `cat $ips`
		do 
			ratein=`echo $ip | $CUT -d ":" -f 2`
			rateout=`echo $ip | $CUT -d ":" -f 3`
			ip=`echo $ip | $CUT -d ":" -f 1`


			#entrada
			$TC class add dev $redelocal parent 1: classid 1:$mark cbq bandwidth 100Mbit rate "$ratein"Kbit weight `$EXPR $ratein / 10`Kbit prio 5 allot 1514 cell 8 maxburst 20 avpkt 1000 bounded
			$TC qdisc add dev $redelocal parent 1:$mark handle $mark sfq perturb 10
			$TC filter add dev $redelocal parent 1:0 protocol ip prio 200 handle $mark fw classid 1:$mark
			$IPTABLES -t mangle -A POSTROUTING -d $ip -j MARK --set-mark $mark


			#Saida 
			$TC class add dev $internet parent 1: classid 1:$mark cbq bandwidth 10Mbit rate "$rateout"Kbit weight `$EXPR $rateout / 10`Kbit prio 5 allot 1514 cell 8 maxburst 20 avpkt 1000 bounded
			$TC qdisc add dev $internet parent 1:$mark handle $mark  sfq perturb 10
			$TC filter add dev $internet parent 1:0 protocol ip prio 200 handle $mark fw classid 1:$mark
			$IPTABLES -t mangle -A FORWARD -s $ip -j MARK --set-mark $mark
			#################################################################
			mark=`$EXPR $mark + 1`
		done

		if [ $redelocal2 != "inexistente" ]
		then		
			for ip in `cat $ips2`
			do 
				ratein=`echo $ip | $CUT -d ":" -f 2`
				rateout=`echo $ip | $CUT -d ":" -f 3`
				ip=`echo $ip | $CUT -d ":" -f 1`

				#entrada
				$TC class add dev $redelocal2 parent 1: classid 1:$mark cbq bandwidth 10Mbit rate "$ratein"Kbit weight `$EXPR $rateout / 10`Kbit prio 5 allot 1514 cell 8 maxburst 20 avpkt 1000 bounded
				$TC qdisc add dev $redelocal2 parent 1:$mark handle $mark sfq perturb 10
				$TC filter add dev $redelocal2 parent 1:0 protocol ip prio 200 handle $mark fw classid 1:$mark
					$IPTABLES -t mangle -A POSTROUTING -d $ip -j MARK --set-mark $mark

				#Saida 
				$TC class add dev $internet parent 1: classid 1:$mark cbq bandwidth 10Mbit rate "$rateout"Kbit weight `$EXPR $rateout / 10`Kbit prio 5 allot 1514 cell 8 maxburst 20 avpkt 1000 bounded
				$TC qdisc add dev $internet parent 1:$mark handle $mark  sfq perturb 10
				$TC filter add dev $internet parent 1:0 protocol ip prio 200 handle $mark fw classid 1:$mark
					$IPTABLES -t mangle -A FORWARD -s $ip -j MARK --set-mark $mark
				#################################################################
				mark=`$EXPR $mark + 1`
			done
		fi

}


fstat()
{
	comum
	for iface in `cat $interfaces`
        	        do
				echo " Interface $iface"
				$TC -s qdisc ls dev $iface
				echo ""
                	done
	exit 1
}


##
# Aqui rodamos as opcoes
# Mais amigavel e modular usando estrutura case
#
##
case $1 in

	stop)
		if [ -d /etc/controle_banda ]
		then
			fstop
		else
			echo "Sistema nao instalado"
			exit 1
		fi
		;;

	start)
		if [ -d /etc/controle_banda ]
		then
			fstart
		else
			echo "Sistema nao instalado"
			exit 1
		fi
		;;
	restart)
		if [ -d /etc/controle_banda ]
		then
			fstop
			fstart
		else
			echo "Sistema nao instalado"
			exit 1
		fi
		;;
	install)
		finstall
		;;
	stat)
		fstat
		;;
	*)
		echo "Uso: $0 (stop|start|restart|install|stat)"
		;;
esac
